package main

import (
	"encoding/json"
	"log"

	"git.science.uu.nl/datastrophe/query-conversion/cypher"
	"git.science.uu.nl/datastrophe/query-conversion/entity"
)

func main() {
	queryservice := cypher.NewService()

	js := []byte(`{
		"return": {
			"entities": [
				0
			]
		},
		"entities": [
			{
				"type": "airports",
				"constraints": [
					{
						"attribute": "city",
						"value": "San Francisco",
						"dataType": "text",
						"matchType": "exact"
					}
				]
			}
		],
		"limit": 5000
	}`)

	// js := []byte(`{
	// 	"return": {
	// 		"entities": [
	// 			0,
	// 			1,
	// 			2
	// 		],
	// 		"relations": [
	// 			0,
	// 			1
	// 		]
	// 	},
	// 	"entities": [
	// 		{
	// 			"type": "airports",
	// 			"constraints": [
	// 				{
	// 					"attribute": "city",
	// 					"value": "New York",
	// 					"dataType": "text",
	// 					"matchType": "exact"
	// 				}
	// 			]
	// 		},
	// 		{
	// 			"type": "airports",
	// 			"constraints": [
	// 				{
	// 					"attribute": "city",
	// 					"value": "San Francisco",
	// 					"dataType": "text",
	// 					"matchType": "exact"
	// 				}
	// 			]
	// 		},
	// 		{
	// 			"type": "airports",
	// 			"constraints": [
	// 				{
	// 					"attribute": "state",
	// 					"value": "HI",
	// 					"dataType": "text",
	// 					"matchType": "exact"
	// 				}
	// 			]
	// 		}
	// 	],
	// 	"relations": [
	// 		{
	// 			"type": "flights",
	// 			"depth": {
	// 				"min": 1,
	// 				"max": 3
	// 			},
	// 			"entityFrom": 2,
	// 			"entityTo": 1,
	// 			"constraints": [
	// 				{
	// 					"attribute": "Day",
	// 					"value": "15",
	// 					"dataType": "number",
	// 					"matchType": "EQ"
	// 				}
	// 			]
	// 		},
	// 		{
	// 			"type": "flights",
	// 			"depth": {
	// 				"min": 1,
	// 				"max": 1
	// 			},
	// 			"entityFrom": 0,
	// 			"entityTo": -1,
	// 			"constraints": []
	// 		}
	// 	],
	// 	"limit": 5000
	// }`)

	var inc entity.IncomingQueryJSON
	json.Unmarshal(js, &inc)
	result, _ := queryservice.ConvertQuery(&inc)
	log.Println(*result)
}
